unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, ComCtrls,

  //BGRABitmapTypes,
  BGRABitmap, BGRASVG, BGRAUnits;

type

  { TForm1 }

  TForm1 = class(TForm)
    BtnTest2: TButton;
    Image1: TImage;
    Label1: TLabel;
    Panel1: TPanel;
    TrackBar1: TTrackBar;
    procedure BtnTest2Click(Sender: TObject);
    procedure BtnTest1Click(Sender: TObject);
    Function StringToStream(const AString: string): TStream;

  private
    { private declarations }
  public
    { public declarations }
    procedure Test1;
    procedure Test2;

  end;

var
  Form1: TForm1;
  Test1SVGcontent: String = '<?xml version="1.0" encoding="utf-8"?><!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd"><svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"	 width="32px" height="32px" viewBox="0 0 32 32" enable-background="new 0 0 32 32" xml:space="preserve"><g>	<path fill="#559955" d="M1,16C1,7.72,7.71,1,16,1c8.279,0,15,6.72,15,15c0,8.29-6.721,15-15,15C7.71,31,1,24.29,1,16z"/>	<polygon fill="#FFFFFF" points="12,8 12,24 23,15.77 	"/></g></svg>';
  Test2SVGcontent: String = '<?xml version="1.0" encoding="utf-8"?><!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd"> <svg version="1.1" id="Ebene_1" xmlns:svg="http://www.w3.org/2000/svg" 	 xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" width="16.527px" 	 height="24.076px" viewBox="0 0 16.527 24.076" enable-background="new 0 0 16.527 24.076" xml:space="preserve"> <g id="breadboard"> 	<rect id="connector0pin" x="0.001" y="22.997" fill="none" width="2.16" height="0.999"/> 	<rect id="connector1pin" x="7.181" y="22.997" fill="none" width="2.159" height="0.999"/> 	<rect id="connector2pin" x="14.366" y="22.997" fill="none" width="2.16" height="0.999"/> 	 		<line id="connector0leg" fill="none" stroke="#8C8C8C" stroke-width="2.16" stroke-linecap="round" x1="1.081" y1="24.076" x2="1.081" y2="31.255"/> 	 		<line id="connector1leg" fill="none" stroke="#8C8C8C" stroke-width="2.16" stroke-linecap="round" x1="8.26" y1="24.076" x2="8.26" y2="31.255"/> 	 		<line id="connector2leg" fill="none" stroke="#8C8C8C" stroke-width="2.16" stroke-linecap="round" x1="15.446" y1="24.076" x2="15.446" y2="31.255"/> 	<rect id="rect9506" x="7.178" y="14.729" fill="#8C8C8C" width="2.153" height="9.349"/> 	<path id="path9510" fill="#8C8C8C" d="M3.288,14.729v3.315c0,0.425-0.782,1.06-1.198,1.425c-1.024,0.892-2.088,1.82-2.088,2.992 		v1.618h2.154c0,0,0-0.999,0-1.208c0-0.519,0.903-1.39,1.35-1.771c0.997-0.868,1.944-1.688,1.944-2.747v-3.625H3.288L3.288,14.729z" 		/> 	<path id="path9514" fill="#8C8C8C" d="M13.22,14.729v3.315c0,0.425,0.78,1.06,1.198,1.425c1.027,0.892,2.089,1.82,2.089,2.992 		v1.618h-2.153c0,0,0-0.999,0-1.208c0-0.519-0.904-1.39-1.35-1.771c-0.998-0.868-1.945-1.688-1.945-2.747v-3.625H13.22L13.22,14.729 		z"/> 	<rect id="rect9553" x="1.616" y="4.658" fill="#1A1A1A" width="13.276" height="10.068"/> 	<path id="path9555" fill="#141414" d="M13.888,4.658v2.452v8.228v1.843c0.632-0.713,1.004-1.554,1.004-2.453l0,0V4.658H13.888z"/> 	<path id="path9557" fill="#242424" d="M2.622,4.658H1.617v10.068l0,0c0,0.899,0.373,1.74,1.005,2.453v-1.842V7.111V4.658z"/> 	<path id="path9559" fill="#1F1F1F" d="M1.616,4.658L1.616,4.658c0,0.898,0.373,1.739,1.005,2.452h11.274 		C14.527,6.398,14.9,5.557,14.9,4.658l0,0H1.616z"/> 	<path id="path9561" fill="#141414" d="M8.255,0C4.588,0,1.616,2.085,1.616,4.66h13.276C14.892,2.085,11.923,0,8.255,0z"/> 	<rect id="rect9563" x="2.622" y="7.111" width="11.274" height="10.069"/> </g> <text transform="matrix(1 0 0 1 3.6531 12.8127)" fill="#FFFFFF" font-family="''Droid Sans''" font-size="3.4819">TRIAC</text> </svg>';

implementation

{$R *.lfm}

procedure TForm1.Test1;
Var
 bmp: TBGRABitmap;
 svg: TBGRASVG;
begin
 bmp:= TBGRABitmap.Create;
 try
//  svg:= TBGRASVG.Create('svg\test1.svg');
  svg:= TBGRASVG.Create(StringToStream(Test1SVGcontent));
  try
   bmp.SetSize(Round(svg.Width.value),Round(svg.Height.value));
   svg.Draw(bmp.Canvas2D, 0,0, cuPixel);
   Image1.Picture.Bitmap.Assign(bmp);
  finally
   svg.Free;
  end;
 finally
  bmp.Free;
 end;
end;

procedure TForm1.Test2;
Var
 bmp: TBGRABitmap;
 svg: TBGRASVG;
begin
 bmp:= TBGRABitmap.Create;
 try
//  svg:= TBGRASVG.Create('svg\test2.svg');
  svg:= TBGRASVG.Create(StringToStream(Test2SVGcontent));
  try
   bmp.SetSize(Round(TrackBar1.Position),Round(TrackBar1.Position));
   svg.StretchDraw(bmp.Canvas2D, taCenter, tlCenter, 0,0,TrackBar1.Position,TrackBar1.Position);
   Image1.Picture.Bitmap.Assign(bmp);
  finally
   svg.Free;
  end;
 finally
  bmp.Free;
 end;
end;

procedure TForm1.BtnTest1Click(Sender: TObject);
begin
 Test1;
end;

procedure TForm1.BtnTest2Click(Sender: TObject);
begin
 Test2;
end;

Function TForm1.StringToStream(const AString: string): TStream;
begin
  Result := TStringStream.Create(AString);
end;

end.

